// mailutil.cpp
// Copyright 1997 Jarle Aase
//
// This code might be freely used commercially and non-commercially
// under the following restrictions:
// No use is allowed by any governmental agencies or organizations
// in any country. This includes commercial companys 100% owned by
// the government. Universities and schools might use the code and library
// as they wish.
// THIS CODE IS NOT TO BE USED BY ANYONE IN ORDER TO GENERATE COMMERCIAL
// OR NON-COMMERCIAL SPAM-MAIL, OR SPAM POSTINGS ON USENET.
//
// These terms applies for the code and library, and programs compiled from
// this code and code derived from this code and library.
//
//////////////////////////////////////////////////////////////////////////////////
//
// Send-mail/post news message library.
// derived from the original wSendmail 1.6 source code
//
// Copyright and contributor information:
// 
// Idea and original implementation: Jarle Aase, Jgaa's Internet
// MIME code taken from Bell Communications Research, Inc. (Bellcore)
// Arpadate taken from Eric P. Allman,  University of California.
//
// Other contributors (to wSendmail - the original code for this library)
// Wsendmail: Jarle Aase, Jgaa's Internet
// multi-reciptients code: M. Spoek
// News posting modification: Wim van der Vegt
// Bugfixes: Steve Russo, Digital Equipment Corp.
//
//
/* Original copyright for MIME code
Permission to use, copy, modify, and distribute this material 
for any purpose and without fee is hereby granted, provided 
that the above copyright notice and this permission notice 
appear in all copies, and that the name of Bellcore not be 
used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of an authorized representative of Bellcore.  BELLCORE 
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY 
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", 
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.

/* Original copyright for arpadate code
 *
 * Copyright (c) 1983, 1995, 1996 Eric P. Allman
 * Copyright (c) 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
////////////////////////////////////////////////////////////////////////////////////
// Implementation and changes
////////////////////////////////////////////////////////////////////////////////////
// Jgaa: April 16 997 - ver 1.0
//			wSemdmail is discontinued. The source code is split up in
//      2 new modules, MailUtil.lib and wSendTo.exe
//      Currently CGI-BIN mode is unsupported
//      The mail library contain code to handle message headers and
//      MIME encoded attachments, the command line program handles
//      sending of email and news messages from the command line.
//      A GCI version comatible with wSendmail is planned.
//

#define DO_SMTP 1 // Set to 0 to compile non SMTP version

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <process.h>
#include <time.h>

#define MAILLIB "MailUtil for Win32, Copyright 1997 by Jarle Aase"


#if DO_SMTP
#include <windows.h>
#else
extern unsigned int GetTickCount();
#endif 

#include "mailutil.h"
#define index(a,b) strchr(a,b)


//////////////////////////////////////////////////////////////////////////////
// CMailPart


CMailPart::CMailPart(CMailUtil *pFather)
{
	istext = 1;
	isrich = 0;
	content_type = "text/plain";
	encoding_type_needed = ENC_NONE;
	mail_tmpnam(filename);
	next = prev = NULL;
	FirstPart = pFather->GetFirstPart();
	buffer = NULL;
	pOrigin = pFather;
	CharacterSet = getenv("MM_CHARSET");
	if (!CharacterSet)
		CharacterSet = "iso-8859-1";
	content_disposition[0] = 0;
	content_buffer[0] = 0;

	// Link it
	CMailPart *pTest = FirstPart;
	while(pTest && pTest->next)
		pTest = pTest->next;
	
	if (pTest)
	{
		pTest->next = this;
		prev = pTest;
	}
}

CMailPart::~CMailPart()
{
	if (next)
		delete next; // Recursive delete of the list
}

// Return 0 on success
int CMailPart::Create(const char *Text, int Type, int DoConvertCharset)
{
	int buflen = 0;
	char *tmpbuf = NULL;
	unsigned char *p;
	const char *fname;
	int DontCopy = 0;

	if (!pOrigin->UsingMime())
	{
		if (Type == BINARY)
		{
			if (pOrigin->VerboseFlag || pOrigin->DebugFlag)
				fprintf(stderr,"You must enable MIME encoding in order to send attachments.\n");
			pOrigin->error_val = FAILED_TO_PARSE_ARGUMENTS;
		}

		// Don't use mime. Send raw text
		Type = ASCII_HEADER;
		encoding_type_needed = ENC_NONE;
	}

	switch(Type)
	{
		case ASCII_TEXTFILE_INCLUCE:
			// Dirty hook.. Read the file in as a text buffer, as if it was
			// added interactivly
			{
				struct _stat st;
				if (_stat(Text, &st))
					return -1;

				buflen = st.st_size;

				FILE *fp = fopen(Text, "rb");
				if (!fp)
					return -1;

				buffer = (char *)malloc(buflen) +1;
				int ch;
				p = (unsigned char *)buffer;
				while((buflen-- > 0) && ((ch = getc(fp)) != EOF))
					*p++ = (unsigned char)ch;
				*p++ = 0;
				fclose(fp);
				Text = buffer;
				DontCopy = 1;
			}
		case ASCII_GENERIC:
			p = (unsigned char *)Text;
			while(*p)
			{
				if (*p > 127)
					goto iso;
				++p;
			}
			// Just use US 7 bit...
		case ASCII_7BITUS:
			encoding_type_needed = ENC_QP;

		case ASCII_HEADER:
			if (DontCopy == 0)
				buffer = strdup(Text);
			break;

		case ASCII_ISO8859:
iso:
			encoding_type_needed = ENC_QP;
			if (DontCopy == 0)
				buffer = strdup(Text);
			if (DoConvertCharset)
				OemToChar(Text, buffer);
			break;

		case BINARY:
			// Text is a filename
			istext = 0;
			encoding_type_needed = ENC_B64;
			content_type = GetContentType(Text, content_buffer);

			fname = strrchr(Text,'\\');
			if (fname)
				++fname;
			else
				fname = Text;
			sprintf(content_disposition, "attachment; filename=\"%s\"", fname);
			buffer = strdup(Text);
	}

	return 0;
}

void CMailPart::WriteContentTypeAndEncoding(FILE *fp)
{
	if (istext) 
	{
		if (isrich) 
		{
			fprintf(fp, "Content-type: text/richtext; charset=%s\r\n", CharacterSet);
		} 
		else 
		{
			fprintf(fp, "Content-type: text/plain; charset=%s\r\n", CharacterSet);
		}
	} 
	else 
	{
		fprintf(fp, "Content-type: ");
		WriteCtypeNicely(fp, content_type); /* fixes some syntactic junk */
		if (*content_disposition)
			fprintf(fp,"Content-Disposition: %s\r\n", content_disposition);
	}
	if (istext && isrich && (encoding_type_needed == ENC_NONE))
	{
		/* Don't you believe it... */
		encoding_type_needed = ENC_QP;
	}
    
	if (encoding_type_needed == ENC_B64) 
	{
		fprintf(fp, "Content-Transfer-Encoding: base64\r\n");
	} 
	else if (encoding_type_needed == ENC_QP) 
	{
		fprintf(fp, "Content-Transfer-Encoding: quoted-printable\r\n");
	}
}

void CMailPart::WriteCtypeNicely(FILE *fp, char *ct)
{
    char *semi, *slash, *eq, *s;

    for (s = ct; *s; ++s) {
        if (*s == '\r\n') *s = ' ';
    }
    semi = (char *) index(ct, ';');
    if (semi) *semi = '\0';
    slash = (char *) index(ct, '/');
    fputs(ct, fp);
    if (!slash) fputs("/unknown", fp);
    while (semi) {
        ct = semi + 1;
        *semi = ';';
        semi = (char *) index(ct, ';');
        if (semi) *semi = '\0';
        eq = (char *) index(ct, '=');
        if (eq) *eq = '\0';
        fputs(";\r\n\t", fp);
        while (isspace(*ct)) ++ct;
        fputs(ct, fp);
        if (eq) {
            s = eq;
            fputs("=", fp);
            ++s;
            while (isspace(*s)) ++s;
            fputsquoting(s, fp);
            *eq = '=';
        }
    }
    fputs("\r\n", fp);
}

void CMailPart::fputsquoting(char *s, FILE *fp)
{
    char *end = s + strlen(s) - 1;
    while (isspace(*end) && end > s) --end;
    if (*s == '\"') {
        putc(*s, fp);
        while (*++s) {
            if (*s == '\"') break; /* MAY TERMINATE EARLY! */
            if (*s == '\\') {
                putc(*s, fp);
                ++s; /* Don't check this next char */
                if (!*s) break;
            }
            putc(*s, fp);
        }
        putc('\"', fp);
    } else {
        putc('\"', fp);
        putc(*s, fp);
        while (*++s) {
            if (*s == '\"' || *s == '\\') {
                putc('\\', fp);
            }
            putc(*s, fp);
        }
        putc('\"', fp);
    }
}
        
        
void CMailPart::controlputc(char c)
{
    fputc(c, stdout);
}


void CMailPart::TranslateInputToEncodedOutput(FILE *OutFile)
{
	if (!istext)
	{
		// File
		FILE *fp = fopen(buffer, "rb");
		if (!fp)
		{
			if (pOrigin->VerboseFlag || pOrigin->DebugFlag)
				fprintf(stderr,"Unable to open include file '%s'. Aborting.\n", buffer);
			pOrigin->error_val = FAILED_TO_OPEN_TMP_FILE;
		}

		TranslateInputToEncodedOutput(fp, OutFile);
	}
	else
	{
		// Memory
		TranslateInputToEncodedOutput(buffer, OutFile);
	}
}


void CMailPart::TranslateInputToEncodedOutput(FILE *InputFile, FILE *OutFile)
{
	int c;

	switch(encoding_type_needed) 
	{
		case ENC_B64:
			to64(InputFile, OutFile);
			break;
		case ENC_QP:
			toqp(InputFile, OutFile);
			break;
		default:
			while ((c = getc(InputFile)) != EOF)
				putc(c, OutFile);
	}
}

void CMailPart::TranslateInputToEncodedOutput(const char *Text, FILE *OutFile)
{
	switch(encoding_type_needed) 
	{
		case ENC_B64:
			to64(Text, OutFile);
			break;
		case ENC_QP:
			toqp(Text, OutFile);
			break;
		default:
			fputs(Text, OutFile);
	}
}

static char basis_64[] =
   "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

void CMailPart::to64(FILE *infile, FILE *outfile) 
{
	int c1, c2, c3, ct=0;
#ifdef _DEBUG
	int count = 0;
#endif
	while ((c1 = getc(infile)) != EOF) 
	{
		c2 = getc(infile);
		if (c2 == EOF) 
		{
			output64chunk(c1, 0, 0, 2, outfile);
		} 
		else 
		{
			c3 = getc(infile);
			if (c3 == EOF) 
			{
				output64chunk(c1, c2, 0, 1, outfile);
			} 
			else 
			{
				output64chunk(c1, c2, c3, 0, outfile);
			}
		}
		ct += 4;
		if (ct > 75) 
		{
			fputs("\r\n", outfile);
#ifdef _DEBUG
			count += ct;
#endif
			ct = 0;
		}
	}
	if (ct) 
		fputs("\r\n", outfile);
#ifdef _DEBUG
	count += ct;
#endif
	fflush(outfile);
}

#define getct(a) (*a ? (int)*a++ : EOF)

void CMailPart::to64(const char *Text, FILE *outfile) 
{
    int c1, c2, c3, ct=0;
    while ((c1 = getct(Text)) != EOF) {
        c2 = getct(Text);
        if (c2 == EOF) {
            output64chunk(c1, 0, 0, 2, outfile);
        } else {
            c3 = getct(Text);
            if (c3 == EOF) {
                output64chunk(c1, c2, 0, 1, outfile);
            } else {
                output64chunk(c1, c2, c3, 0, outfile);
            }
        }
        ct += 4;
        if (ct > 71) {
            fputs("\r\n", outfile);
            ct = 0;
        }
    }
    if (ct) fputs("\r\n", outfile);
    fflush(outfile);
}

void CMailPart:: output64chunk(int c1, int c2, int c3, int pads, FILE *outfile)
{
    putc(basis_64[c1>>2], outfile);
    putc(basis_64[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)], outfile);
    if (pads == 2) {
        putc('=', outfile);
        putc('=', outfile);
    } else if (pads) {
        putc(basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)], outfile);
        putc('=', outfile);
    } else {
        putc(basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)], outfile);
        putc(basis_64[c3 & 0x3F], outfile);
    }
}


static char basis_hex[] = "0123456789ABCDEF";

void CMailPart::toqp(FILE *infile, FILE *outfile) 
{
    int c, ct=0, prevc=255;
    while ((c = getc(infile)) != EOF) {
        if ((c < 32 && (c != '\n' && c != '\t' && c != '\r'))
             || (c == '=')
             || ((c >= 127))) {
            putc('=', outfile);
            putc(basis_hex[c>>4], outfile);
            putc(basis_hex[c&0xF], outfile);
            ct += 3;
            prevc = 'A'; /* close enough */
        } else if (c == '\n') {
            if (prevc == ' ' || prevc == '\t') {
                putc('=', outfile); /* soft & hard lines */
                putc(c, outfile);
            }
            putc(c, outfile);
            ct = 0;
            prevc = c;
        } else {
            putc(c, outfile);
            ++ct;
            prevc = c;
        }
        if (ct > 72) {
            putc('=', outfile);
            fputs("\r\n", outfile);
            ct = 0;
            prevc = '\n';
        }
    }
    if (ct) {
        putc('=', outfile);
        fputs("\r\n", outfile);
    }
}

void CMailPart::toqp(const char *TextBuf, FILE *outfile) 
{
	unsigned const char *Text = (unsigned const char *)TextBuf;
    int c, ct=0, prevc=255;
    while ((c = getct(Text)) != EOF) {
        if ((c < 32 && (c != '\n' && c != '\t') && (c != '\r'))
             || (c == '=')
             || ((c >= 127))) {
            putc('=', outfile);
            putc(basis_hex[c>>4], outfile);
            putc(basis_hex[c&0xF], outfile);
            ct += 3;
            prevc = 'A'; /* close enough */
        } else if (c == '\n') {
            if (prevc == ' ' || prevc == '\t') {
                putc('=', outfile); /* soft & hard lines */
                putc(c, outfile);
            }
            putc(c, outfile);
            ct = 0;
            prevc = c;
        } else {
            putc(c, outfile);
            ++ct;
            prevc = c;
        }
        if (ct > 72) {
            putc('=', outfile);
            fputs("\r\n", outfile);
            ct = 0;
            prevc = '\n';
        }
    }
    if (ct) {
        putc('=', outfile);
        fputs("\r\n", outfile);
    }
}


//////////////////////////////////////////////////////////////////////////////
// CMailUtil

int CMailUtil::DebugFlag = 0;
int CMailUtil::VerboseFlag = 0;
char CMailUtil::Organization[127];

CMailUtil::CMailUtil()
{
	boundary[0] = 0;
	FirstPart = NULL;
	FirstHeaderLine = NULL;
	AdrList = NULL;
	error_val.error_code = 0;
	convert_charset = 0; // OEM to ANSI conversion
	mode = MODE_SMTP;
	DoMime = TRUE;
}

CMailUtil::~CMailUtil()
{
	if (AdrList)
		free(AdrList);

	if (FirstHeaderLine)
		delete FirstHeaderLine;

	if (FirstPart)
		delete FirstPart;
}

int CMailUtil::AddHdrLine(const char *tag, const char *Text, int DoSeperate)
{
	CMailHeaderLine *pHdr = CMailHeaderLine::AddHeader(tag, Text, FirstHeaderLine, DoSeperate);
	if (!FirstHeaderLine)
		FirstHeaderLine = pHdr;

	return 0;
}

int CMailUtil::AddSegment(const char *Text, int Type)
{
	CMailPart *pNode = new CMailPart(this);
	if (!FirstPart)
		FirstPart = pNode;

	return pNode->Create(Text, Type, convert_charset);
}

// Encode the email. Write content to OutFile
int CMailUtil::WriteOutMessage(FILE *OutFile)
{
	try
	{
		_WriteOutMessage(OutFile);
	}
	catch(CSMTPError *e)
	{
		return e->error_code;
	}
	catch(...)
	{
		fprintf(stderr,"CMailUtil::WriteOutMessage() - Fatal error - processing aborted.\n");
		return -1;
	}
}

int CMailUtil::_WriteOutMessage(FILE *OutFile)
{
	CMailPart *pNode = FirstPart;

	// Write mail header
	if (UsingMime())
		AddHdrLine("MIME-Version", "1.0");

	AddHdrLine("X-MailLibrary", MAILLIB);
	if (!*HdrValue("From", ""))
		SetFrom(HdrValue("X-Sender"));

	if (*Organization)
		AddHdrLine("Organization", Organization);

	if (!FirstPart)
		return 0; // Emptty body

	if (FirstPart->next && UsingMime())
	{
		// Multipart
		char boundary[120];
		char buf[200];
		sprintf(boundary, "PART.BOUNDARY.MU.%d.%d.%d", _getpid(), time(0), GetTickCount());
		sprintf(buf, "multipart/mixed;\r\n\tboundary=%s\r\n\r\n", boundary);
		AddHdrLine("Content-type", buf);
		FirstHeaderLine->PrintHdr(OutFile);
		fprintf(OutFile, "> THIS IS A MESSAGE IN 'MIME' FORMAT.  Your mail reader does not support MIME.\r\n> Some parts of this will be readable as plain text.\r\n> To see the rest, you will need to upgrade your mail reader.\r\n");
		while(pNode) 
		{
			/* First check to see if it is empty & text, in which case skip it */
			if (pNode->istext) 
			{
				struct stat stbuf;
				if (!stat(pNode->filename, &stbuf)) 
				{
					if (stbuf.st_size == 0) 
					{
						pNode = pNode->next;
						continue;
					}
				}
			}
			
			fprintf(OutFile, "\r\n--%s\r\n", boundary);
			pNode->WriteContentTypeAndEncoding(OutFile);
			fprintf(OutFile, "\r\n");
			pNode->TranslateInputToEncodedOutput(OutFile);
			pNode = pNode->next;
		}
		fprintf(OutFile, "\r\n--%s--\r\n", boundary);
	}
	else if (UsingMime())
	{
		// Not multipart
		FirstHeaderLine->PrintHdr(OutFile);
		pNode->WriteContentTypeAndEncoding(OutFile);
		fprintf(OutFile, "\r\n");
		pNode->TranslateInputToEncodedOutput(OutFile);
	}
	else
	{
		// Mo mime. Use raw text
		FirstHeaderLine->PrintHdr(OutFile);
		fprintf(OutFile, "\r\n");
		pNode->TranslateInputToEncodedOutput(OutFile);
	}
	
	return 0;
}


void CMailUtil::SetTo(const char *Name, const char *Email)
{
	if (mode == MODE_SMTP)
		AddAdressee("To", Name, Email);
	else
		AddAdressee("Newsgroups", NULL, Email);
}

void CMailUtil::SetCc(const char * Name, const char *Email)
{
	if (mode == MODE_NNTP)
	{
		if (VerboseFlag || DebugFlag)
			fprintf(stderr,"Cc (Carbon Copy) is not legal in News posting mode. Aborting.\n");
		error_val = FAILED_TO_PARSE_ARGUMENTS;
	}
	
	AddAdressee("Cc", Name, Email);
}

void CMailUtil::SetBcc(const char * Email)
{
	if (mode == MODE_NNTP)
	{
		if (VerboseFlag || DebugFlag)
			fprintf(stderr,"Bcc (Blind Carbon Copy) is not legal in News posting mode. Aborting.\n");
		error_val = FAILED_TO_PARSE_ARGUMENTS;
	}
	AddAdressee(NULL, NULL, Email);
}

// If Email[0] == '@', treat as addressee file
void CMailUtil::AddAdressee(const char *Tag, const char *Name, const char *Email)
{
	char buf[127];

	if (*Email == '@')
	{
		// Treat as file
		FILE *fp = fopen(Email +1, "r");
		if (!fp)
		{
			if (VerboseFlag || DebugFlag)
				fprintf(stderr,"Failed to open address file '%s'. Aborting.\n", Email);
			error_val = FAILED_TO_PARSE_ARGUMENTS;
		}

		while(fgets(buf, sizeof(buf), fp))
		{
			char *p = buf;
			while(*p)
			{
				if (!isalnum(*p) && !strchr(".-_@<> '\"", *p))
				{
					*p = 0;
					break;
				}
				++p;
			}
			AddAdressee(Tag, NULL, buf);
		}

		fclose(fp);
		return;
	}

	if (Tag && *Tag)
	{
		// Add to header
		if (Name && *Name)
			sprintf(buf,"\"%s\" <%s>", Name, Email);
		else
			strcpy(buf,Email);

		AddHdrLine(Tag, buf, 1);
	}

	if (!Tag || strcmp(Tag,"From"))
	{
		if (AdrList)
		{
			sprintf(buf,",%s", Email);
			AdrList = (char *)realloc(AdrList, strlen(AdrList) + strlen(buf) +1);
			strcat(AdrList, buf);
		}
		else
			AdrList = strdup(Email);
	}
}

void CMailUtil::SetPriority(int Pri)
{
	if ((Pri > 5) || (Pri < 1))
		return; // Illegal priority

	char buf[16];
	sprintf(buf,"%d", Pri);

	AddHdrLine("X-Priority", buf);
}

void CMailUtil::SetFrom(const char *From)
{
	AddHdrLine("From", From);
	if (!CMailHeaderLine::Find("X-Sender", FirstHeaderLine))
		SetReturnPath(From);
}

void CMailUtil::SetSubject(const char *Subject)
{
	AddHdrLine("Subject", Subject);
}

void CMailUtil::SetReturnPath(const char *ReturnPath)
{
	char buf[127];
	char *pp = buf;
	const char *p = strchr(ReturnPath, '<');
	if (!p)
		p = ReturnPath;

	while(*p && (*p != '>'))
		*pp++ = *p++;

	*pp = 0;

	AddHdrLine("X-Sender", buf);
}

void CMailUtil::AddDateHdr(const char *Text)
{
	char buf[43 + TZNAME_MAX];
	if (!Text)
	{
		if (CMailHeaderLine::Find("Date", FirstHeaderLine))
			return; // Dont set.

		arpadate(NULL, buf);
	}
	AddHdrLine("Date", Text ? Text : buf);
}

const char *CMailUtil::HdrValue(const char *Tag, const char *Def)
{
	CMailHeaderLine *pHdr = CMailHeaderLine::Find(Tag, FirstHeaderLine);

	if (pHdr)
		return pHdr->GetText();

	return Def;
}

///////////////////////////////////////////////////////////////////////////////////////
// CMailHeaderLine

CMailHeaderLine::CMailHeaderLine()
{
	tag = NULL;
	buffer = NULL;
	next = NULL;
}

CMailHeaderLine::~CMailHeaderLine()
{
	if (next)
		delete next;

	if (buffer)
		free(buffer);
}

CMailHeaderLine *CMailHeaderLine::AddHeader(const char *Tag, const char *Text, CMailHeaderLine *pFirst, int DoSeperate)
{
	CMailHeaderLine *pHdr = Find(Tag, pFirst), *pPrev = pFirst;
	if (pHdr && DoSeperate)
	{
		pHdr->Add(Text, 1);
	}
	else if (pHdr)
	{
		// Replace
		free(pHdr->buffer);
		pHdr->buffer = strdup(Text);
	}
	else
	{
		while(pPrev && pPrev->next)
			pPrev = pPrev->next;

		// Create a new header
		pHdr = new CMailHeaderLine;	
		if (pPrev)
			pPrev->next = pHdr;
		pHdr->buffer = strdup(Text);
		pHdr->tag = Tag;
	}

	return pHdr;
}

// Add more text to an existant header
void CMailHeaderLine::Add(const char *Text, int DoSeperate)
{
	char buf[16];
	buf[0] = 0;

	// Find out if we need to split the line
	int linelen = 0;
	const char *p = buffer;
	while(*p)
	{
		if ((*p == '\'r') || (*p == '\n'))
			linelen = 0;
		++linelen;
		++p;
	}

	if (DoSeperate)
		strcat(buf,",");

	if (linelen > 75)
		strcat(buf,"\r\n\t");

	int len = strlen(Text) + strlen(buffer) + strlen(buf) + 1;

	buffer = (char *)realloc(buffer, len);
	if (buf[0])
		strcat(buffer, buf);
	strcat(buffer, Text);
}

CMailHeaderLine *CMailHeaderLine::Find(const char *Tag, CMailHeaderLine *pFirst)
{
	while(pFirst)
	{
		if (!stricmp(Tag, pFirst->tag))
			break;
		pFirst = pFirst->next;
	}
	return pFirst;
}

void CMailHeaderLine::PrintHdr(FILE *OutFp)
{
	CMailHeaderLine *pHdr = this;

	while(pHdr)
	{
		fprintf(OutFp, "%s: %s\r\n", pHdr->tag, pHdr->buffer);
		pHdr = pHdr->next;
	}
	//fputs("\r\n", OutFp);
	fflush(OutFp);
}


///////////////////////////////////////////////////////////////////////////////////////
// SMTP support

#if DO_SMTP

int CSMTPEmail::DoHandleWinsock = TRUE;
int CSMTPEmail::NumObjects = 0;
int CSMTPEmail::NetIsStarted = 0;
char CSMTPEmail::Host[127] = {"mail.somewhere.com"};
char CSMTPEmail::LocalHost[LOCAL_HOST_NAME_LEN];
char CSMTPEmail::NNTPHost[127];
char CSMTPEmail::UserName[32];
char CSMTPEmail::UserPwd[32];

CSMTPEmail::CSMTPEmail()
{
	++NumObjects;
	IsCGI = FALSE;
}

CSMTPEmail::~CSMTPEmail()
{
	--NumObjects;

	if ((NumObjects == 0) && DoHandleWinsock && NetIsStarted)
		WSACleanup();
}

static WSADATA WSAData;

int CSMTPEmail::SendIt()
{

	try
	{
		_SendIt();
	}
	catch(...)
	{
		return error_val.error_code;
	}
}


// Send what we have...
int CSMTPEmail::_SendIt()
{
	SOCKET sc;
	char buf[1024];
	const char *HostName;

	if (DoHandleWinsock && !NetIsStarted && (WSAStartup(MAKEWORD(1, 1), &WSAData) != 0))
		error_val = FAILED_TO_START_SOCKETS;

	NetIsStarted = TRUE;

	// Create Socket
	if ((sc = socket(PF_INET,SOCK_STREAM,0)) == INVALID_SOCKET)
		error_val = FAILED_TO_OBTAIN_SOCKET_HANDLE;


	// Resolve the servers IP
	/*
	struct hostent *adr;
	if (mode == MODE_NNTP)
		adr = (struct hostent *)gethostbyname(HostName = (LPCSTR)NNTPHost);
	else
		adr = (struct hostent *)gethostbyname(HostName = (LPCSTR)Host);
	if (!adr)
		error_val = FAILED_TO_RESOLVE_HOST;
*/

	// Connect to server
	SOCKADDR_IN sin;
	sin.sin_family = AF_INET;

	if (mode == MODE_NNTP)
	{
		HostName = (LPCSTR)NNTPHost;
		sin.sin_port = htons(119);
	}
	else
	{
		HostName = (LPCSTR)Host;
		sin.sin_port = htons(25);
	}
	sin.sin_addr.S_un.S_addr = GetAddr(HostName);
	
	if (connect(sc,(LPSOCKADDR)&sin,sizeof(sin)))
	{
		int err = WSAGetLastError();
		if (DebugFlag || VerboseFlag)
			fprintf(stderr,"Failed to connect to server '%s' port %d. Winsock error: %d\n", 
				HostName, ntohs(sin.sin_port), err);
		error_val = FAILED_TO_CONNECT;
	}

	Ack(sc); // Server welcome message

	if (!LocalHost[0] && gethostname(LocalHost,LOCAL_HOST_NAME_LEN))
	{
		if (DebugFlag)
			fprintf(stderr,"CSMTPEmail::_SendIt() - gethostname() failed. Winsock error code is %d\n", WSAGetLastError());
		error_val = FAILED_TO_GET_HOSTNAME;
	}

	if (mode == MODE_NNTP) // Usenet
	{
		if (*UserName)
		{
			//sprintf(buf,"AUTHINFO USER %s\r\n", User); 
			Post(sc, "AUTHINFO USER ");
			Post(sc, UserName);
			Post(sc, "\r\n");
			Ack(sc);
		}

		if (*UserName && *UserPwd)
		{
			//sprintf(buf,"AUTHINFO PASS %s\r\n", Pass);   
			Post(sc,"AUTHINFO PASS ");
			Post(sc, UserPwd);
			Post(sc, "\r\n");
			Ack(sc);
		}

		// Send usnet groups
		Post(sc, "GROUP ");
		Post(sc, AdrList);
		Post(sc, "\r\n");
		Ack(sc);

		Post(sc,"POST\r\n"); 
		Ack(sc);

		AddHdrLine("Reply-To", HdrValue("X-Sender"));
	}		
	else // Email
	{
		Post(sc, "HELO ");
		Post(sc, LocalHost);
		Post(sc, "\r\n");
		Ack(sc);

		Post(sc, "MAIL FROM: ");
		Post(sc, HdrValue("X-Sender"));
		Post(sc, "\r\n");
		Ack(sc);

		// Send reciptients list
		for(char *p = strtok(AdrList, ", "); p; p = strtok(NULL, ", "))
		{
			Post(sc, "RCPT TO: ");
			Post(sc, p);
			Post(sc,"\r\n");
			Ack(sc);
		}

		Post(sc,"DATA\r\n"); 
		Ack(sc);

		AddHdrLine("Return-Path", HdrValue("X-Sender"));
	}

	AddDateHdr(NULL);

	// Make a tmp file for the actual output...
	char tmpfn[127];
	mail_tmpnam(tmpfn);
	FILE *fp;
	if ((fp = fopen(tmpfn, "w+b")) == NULL)
	{
		if (VerboseFlag || DebugFlag)
				fprintf(stderr,"Unable to open tmp file '%s'. Aborting.\n", tmpfn);
		error_val = FAILED_TO_OPEN_TMP_FILE;
	}

	// Create the data buffer
	int err = WriteOutMessage(fp);
	if (err)
	{
		fclose(fp);
		DeleteFile(tmpfn);
		return err;
	}

	fflush(fp);
	rewind(fp);

	int ch;
	int len = 0;
	while((ch = getc(fp)) != EOF)
	{
		if (len > (sizeof(buf) -1))
		{
			buf[len] = 0;
			Post(sc, buf);
			len = 0;
		}
		buf[len++] = (char)ch;
	}

	if (len)
	{
		buf[len] = 0;
		Post(sc, buf);
	}

	Post(sc, "\r\n.\r\n"); // End of message tag
	Ack(sc);

	Post(sc, "QUIT\r\n");
	Ack(sc);

	fclose(fp);
	DeleteFile(tmpfn);

	return 0;
}

int CSMTPEmail::Post(SOCKET sc, const char *msg)
{
	int len = strlen(msg);
	int slen;
	int index = 0;

	if (DebugFlag)
		fprintf(stderr,"Posting: %s", msg);

	while(len > 0)
	{
		if ((slen = send(sc,msg + index,len,0)) < 1)
		{
			error_val = FAILED_TO_SEND;
			throw sc;
		}
		len -= slen;
		index += slen;
	}
	return TRUE;
}

// Get the response from the server. We only want to know if the
// last command was successful. If any error occurs, we just shut
// down.
int CSMTPEmail::Ack(SOCKET sc)
{
	static LPSTR buf;
	int rlen;
	int Index = 0;
	int Received = 0;

	if (!buf)
	{
		if ((buf = (LPSTR)malloc(1024 * 4)) == NULL)
		{
			error_val = OUT_OF_MEMORY;
			throw sc;
		}
	}

again:
	if ((rlen = recv(sc,buf + Index,((1024 * 4) - 1) - Received,0)) < 1)
	{
		error_val = FAILED_TO_RECEIVE;
		if (DebugFlag)
			fprintf(stderr,"Error: Unable to receive from host\n");
		throw sc;
	}
	Received += rlen;
	buf[Received] = 0;
	if (DebugFlag)
		fprintf(stderr,"Received: (%d bytes) %s", rlen, buf + Index);

	// Check for newline
	Index += rlen;
	if ((buf[Received -2] != '\r') || (buf[Received -1] != '\n'))
	{
		if (DebugFlag)
			fprintf(stderr,"Incomplete server message. Awaiting CRLF\n");
		goto again; // Incomplete data. Line must be terminated by CRLF
	}

	if (buf[0] > '3')
	{
		// Error code
		if (IsCGI)
		{
			printf("<h3>SMTP server error: %s</h3>\n", buf);
		}

		error_val = SERVER_ERROR;
		throw sc;
	}
	return TRUE;
}


// The following code is borrowed from the sample code at http://www.sockets.com
/*-----------------------------------------------------------
 * Function: GetAddr()
 *
 * Description: Given a string, it will return an IP address.
 *   - first it tries to convert the string directly
 *   - if that fails, it tries o resolve it as a hostname
 *
 * WARNING: gethostbyname() is a blocking function
 */
unsigned long CSMTPEmail::GetAddr (const char *szHost) 
{
  LPHOSTENT lpstHost;
  u_long lAddr = INADDR_ANY;
  
  /* check that we have a string */
  if (*szHost) {
  
    /* check for a dotted-IP address string */
    lAddr = inet_addr (szHost);
  
    /* If not an address, then try to resolve it as a hostname */
    if ((lAddr == INADDR_NONE) &&
        (strcmp(szHost, "255.255.255.255"))) {
      
      lpstHost = gethostbyname(szHost);
      if (lpstHost) {  /* success */
        lAddr = *((u_long FAR *) (lpstHost->h_addr));
      } else {  
        lAddr = INADDR_ANY;   /* failure */
      }
    }
  }
  return (lAddr); 
} /* end GetAddr() */


#endif // DO_SMTP

#ifndef lint
static char sccsid[] = "@(#)arpadate.c	8.6 (Berkeley) 9/16/96";
#endif /* not lint */

/*
**  ARPADATE -- Create date in ARPANET format
**
**	Parameters:
	**		ud -- unix style date string.  if NULL, one is created.
**
**	Returns:
**		pointer to an ARPANET date field
**
**	Side Effects:
**		none
**
**	WARNING:
**		date is stored in a local buffer -- subsequent
**		calls will overwrite.
**
**	Bugs:
**		Timezone is computed from local time, rather than
**		from whereever (and whenever) the message was sent.
**		To do better is very hard.
**
**		Some sites are now inserting the timezone into the
**		local date.  This routine should figure out what
**		the format is and work appropriately.
*/

char *arpadate(char *ud, char *b)
{
	register char *p;
	register char *q;
	register int off;
	register int i;
	register struct tm *lt;
	time_t t;
	struct tm gmt;
	char *tz;

	/*
	**  Get current time.
	**	This will be used if a null argument is passed and
	**	to resolve the timezone.
	*/

	(void) time(&t);
	if (ud == NULL)
		ud = ctime(&t);

	/*
	**  Crack the UNIX date line in a singularly unoriginal way.
	*/

	q = b;

	p = &ud[0];		/* Mon */
	*q++ = *p++;
	*q++ = *p++;
	*q++ = *p++;
	*q++ = ',';
	*q++ = ' ';

	p = &ud[8];		/* 16 */
	if (*p == ' ')
		p++;
	else
		*q++ = *p++;
	*q++ = *p++;
	*q++ = ' ';

	p = &ud[4];		/* Sep */
	*q++ = *p++;
	*q++ = *p++;
	*q++ = *p++;
	*q++ = ' ';

	p = &ud[20];		/* 1979 */
	*q++ = *p++;
	*q++ = *p++;
	*q++ = *p++;
	*q++ = *p++;
	*q++ = ' ';

	p = &ud[11];		/* 01:03:52 */
	for (i = 8; i > 0; i--)
		*q++ = *p++;

	/*
	 * should really get the timezone from the time in "ud" (which
	 * is only different if a non-null arg was passed which is different
	 * from the current time), but for all practical purposes, returning
	 * the current local zone will do (its all that is ever needed).
	 */
	gmt = *gmtime(&t);
	lt = localtime(&t);

	off = (lt->tm_hour - gmt.tm_hour) * 60 + lt->tm_min - gmt.tm_min;

	/* assume that offset isn't more than a day ... */
	if (lt->tm_year < gmt.tm_year)
		off -= 24 * 60;
	else if (lt->tm_year > gmt.tm_year)
		off += 24 * 60;
	else if (lt->tm_yday < gmt.tm_yday)
		off -= 24 * 60;
	else if (lt->tm_yday > gmt.tm_yday)
		off += 24 * 60;

	*q++ = ' ';
	if (off == 0)
	{
		*q++ = 'G';
		*q++ = 'M';
		*q++ = 'T';
	}
	else
	{
		tz = NULL;
#if TZ_TYPE == TZ_TM_NAME
		tz = lt->tm_name;
#endif
#if TZ_TYPE == TZ_TM_ZONE
		tz = lt->tm_zone;
#endif
#if TZ_TYPE == TZ_TZNAME
		{
			extern char *tzname[];

			tz = tzname[lt->tm_isdst];
		}
#endif
#if TZ_TYPE == TZ_TIMEZONE
		{
			extern char *timezone();

			tz = timezone(off, lt->tm_isdst);
		}
#endif
		if (off < 0)
		{
			off = -off;
			*q++ = '-';
		}
		else
			*q++ = '+';

		if (off >= 24*60)		/* should be impossible */
			off = 23*60+59;		/* if not, insert silly value */

		*q++ = (off / 600) + '0';
		*q++ = (off / 60) % 10 + '0';
		off %= 60;
		*q++ = (off / 10) + '0';
		*q++ = (off % 10) + '0';
		if (tz != NULL && *tz != '\0')
		{
			*q++ = ' ';
			*q++ = '(';
			while (*tz != '\0' && q < &b[sizeof b - 3])
				*q++ = *tz++;
			*q++ = ')';
		}
	}
	*q = '\0';

	return (b);
}

const char *mail_tmpnam(LPSTR Name)
{
	char *p;
	p = getenv("MAIL_TEMP");
	if (!p)
		p = getenv("TEMP");
	if (!p)
		p = getenv("TMP");
	if (!p)
		p = ".\\";
	
	p = _tempnam(p, "~mail");

	if (!p)
		p = ".\\~mail.tmp";

	strcpy(Name, p);
	return Name;
}

static const char *ImageFileTypes[] = 
{
	{"gif"}, {"jpg"}, {"tif"}, {"tiff"}, {"bmp"}, {"jpeg"}, {"pcd"}, {"png"},  {""}
};

// Get content type from filename
char *GetContentType(const char *FileName, char *buf)
{
	char localbuf[64];
	char RegPath[64];
	char *p = strrchr(FileName, '.');
	char *utype = "unknown";
	*buf = 0;
	const char *filnam = strrchr(FileName, '\\');

	if (filnam)
		++filnam;
	else
		filnam = FileName;

	if (!p)
		goto fail;
	++p;

	utype = p;

	sprintf(RegPath,".%s\\Content Type", p);
	GetRegisteryString(HKEY_CLASSES_ROOT, RegPath, localbuf, 64);

fail:
	if (!*localbuf)
	{
		// Look for some well known file formats...
		const char *mtype = "unknown";
		for(int Index = 0; *ImageFileTypes[Index]; Index++)
		{
			if (!stricmp(ImageFileTypes[Index], p))
			{
				mtype = "image";
				break;
			}
		}
		sprintf(buf,"%s/%s; name=\"%s\"", mtype, utype, filnam);
	}
	else
		sprintf(buf,"%s; name=\"%s\"", localbuf, filnam);

	return buf;
}


const char *GetRegisteryString(HKEY MainKey, LPCSTR Path, char *buffer, int buflen)
{
	DWORD dwNihl, dwSize = buflen;
	LONG Rval;
	HKEY hkey;
	char szKey[MAX_PATH];
	LPSTR Tag;

	strcpy(szKey, Path);
	Tag = strrchr(szKey,'\\');
	*Tag = 0;

	Tag = strrchr(Path,'\\');
	++Tag;

	if ((Rval = RegOpenKeyEx(
		MainKey,
		szKey,
		0,
		KEY_QUERY_VALUE,
		&hkey)) == ERROR_SUCCESS) 
	{
		if ((Rval = RegQueryValueEx(
			hkey,
			Tag,
			NULL,
			&dwNihl,
			(LPBYTE)buffer,
			&dwSize)) == ERROR_SUCCESS)
		{
			return buffer;
		}
		RegCloseKey(hkey);
	}

	*buffer = 0;
	return buffer;
}
